!  Console1.f90 
!
!  FUNCTIONS:
!  Console1 - Entry point of console application.
!

!****************************************************************************
!
!  PROGRAM: Console1
!
!  PURPOSE:  Entry point for the console application.
!
!****************************************************************************

    program UnsOneDim

    implicit none
  ! Constants
    integer N,Np1
    parameter (N = 4)
    parameter (Np1 = N+1)
    ! Variables
    integer:: I,Nt,it
    real:: k,A,h,L,P,th,W,Nu,hp,hL,f,Tinf
    real:: ts,tf,tim,rho,Cp
    real, dimension(Np1):: x,Dx,dxe,T
    real, dimension(Np1):: aE,aW,aP,Sp
    real, dimension(Np1):: Sc,b,Told,ap0,apo
    character*11:: inputFile
    character*10:: outputFile
    real, allocatable:: dt(:)
    inputFile='datainU.txt'
!
! File Operations
!
    open(unit=8,file=inputFile,mode='read')
    !k = 100
    !h = 10
    !W = 0.1
    !th = 0.001
    !L = 0.2
    !f = 1               !implicit scheme
    read(8,*) outputFile
    read(8,*) k,h,Tinf,L,W,th
    read(8,*) rho,cp
    read(8,*) f,ts,tf,Nt
    allocate (dt(Nt))
    read(8,*)((dt(it)),it=1,Nt)
    read(8,*) Told
    close(8)
! Initialization
    Dx = 1.0/N   !  non dimensionalized
    dxe = Dx
    Dx(1) = Dx(2)/2
    Dx(Np1) = Dx(2)/2  ! equal sized volumes
    dxe(Np1)=0          ! no nodes exist beyond the last one
    A = W*th
    P = 2*(W+th)
    Nu = h*L/k
    hp = h*P*L**2
    hL = h*L*A
    Sp = -hp*Dx
    Sc = 0
    tim = 0
    ap0 = rho*cp*L**2*A*Dx
! Half sized boundary volumes
!    Sp(1) = Sp(1)/2.0
!    Sp(Np1) = Sp(Np1)/2.0
! Boundary Conditions
    T(1) = 1     ! specified bc at x=0 and normalized
    open(unit=7,file=outputFile,mode='write')
    write(7,'(''Initial Values at Time = 0'')')
    write(7,'(f10.4)') Told
    
! Coefficients
    aE = 0
    aW = 0
    aE(1:N) = k*A/dxe(1:N)
    aW(2:Np1) = aE(1:N)
    do it=1,Nt
        tim = tim + dt(it)
        apo = ap0/dt(it)
        b = Sc+apo*Told
        aP = aE+aW-Sp+apo
! Bondary Conditions Application
        b(2) = b(2)+aW(2)*T(1)
        aP(Np1) = aP(Np1)+hL
        call TDMA(Np1,aE,aW,aP,b,2,Np1,T)
    ! Body of Console1
!    print *, 'Hello World'
!read *,I
        write(7,'(''Coefficients at Time = '',f10.4)') tim
        write(7,'(''Dt = '', f10.4,//)') dt(it)
write(7,'(4x,''aE'',10x,''aW'',10x,''aP'',10x,''Sp'',10x,\)')
write(7,'(''Sc'',10x,''b'')')
                
        do I=1,Np1
            write(7,10) aE(I),aW(I),aP(I),Sp(I),Sc(I),b(I)
        enddo
        write(7,*)
        write(7,'(f10.4)') T
        Told = T
    enddo

10  format(6(f10.4,2x))    
    
    close(7)
    deallocate(dt)
    end program UnsOneDim


